/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *  
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.it.bcm.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.it.bcm.servlet.ServletListener; 
import se.kth.md.it.bcm.BugzillaCachedAdaptorConstants;
import se.kth.md.it.bcm.resources.IPerson;	
import se.kth.md.it.bcm.resources.IPerson;	
import se.kth.md.it.bcm.resources.IType;	

// Start of user code imports
// End of user code

@OslcNamespace(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE)
@OslcName(BugzillaCachedAdaptorConstants.CHANGEREQUEST) 
@OslcResourceShape(title = "ChangeRequest Resource Shape", describes = BugzillaCachedAdaptorConstants.TYPE_CHANGEREQUEST)
public interface IChangeRequest
{

    public void addAffectedByDefect(final Link affectedByDefect );
    public void addAffectsPlanItem(final Link affectsPlanItem );
    public void addAffectsRequirement(final Link affectsRequirement );
    public void addAffectsTestResult(final Link affectsTestResult );
    public void addBlocksTestExecutionRecord(final Link blocksTestExecutionRecord );
    public void addContributor(final Person contributor );
    public void addCreator(final Person creator );
    public void addDctermsType(final Type type );
    public void addImplementsRequirement(final Link implementsRequirement );
    public void addRelatedChangeRequest(final Link relatedChangeRequest );
    public void addRelatedTestCase(final Link relatedTestCase );
    public void addRelatedTestExecutionRecord(final Link relatedTestExecutionRecord );
    public void addRelatedTestPlan(final Link relatedTestPlan );
    public void addRelatedTestScript(final Link relatedTestScript );
    public void addSubject(final String subject );
    public void addTestedByTestCase(final Link testedByTestCase );
    public void addTracksChangeSet(final Link tracksChangeSet );
    public void addTracksRequirement(final Link tracksRequirement );
    public void addRdfType(final URI type );

	@OslcName("affectedByDefect")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "affectedByDefect")
	@OslcDescription("Change request is affected by a reported defect. It is likely that the target resource will be an oslc_cm:ChangeRequest but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getAffectedByDefect();

	@OslcName("affectsPlanItem")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "affectsPlanItem")
	@OslcDescription("Change request affects a plan item. It is likely that the target resource will be an oslc_cm:ChangeRequest but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getAffectsPlanItem();

	@OslcName("affectsRequirement")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "affectsRequirement")
	@OslcDescription("Change request affecting a Requirement. It is likely that the target resource will be an oslc_rm:Requirement but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getAffectsRequirement();

	@OslcName("affectsTestResult")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "affectsTestResult")
	@OslcDescription("Associated QM resource that is affected by this Change Request. It is likely that the target resource will be an oslc_qm:TestResult but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getAffectsTestResult();

	@OslcName("blocksTestExecutionRecord")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "blocksTestExecutionRecord")
	@OslcDescription("Associated QM resource that is blocked by this Change Request. It is likely that the target resource will be an oslc_qm:TestExecutionRecord but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getBlocksTestExecutionRecord();

	@OslcName("contributor")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "contributor")
	@OslcDescription("Contributor or contributors to the resource. It is likely that the target resource will be a foaf:Person but that is not necessarily the case. ")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.LocalResource)
	@OslcRange({BugzillaCachedAdaptorConstants.TYPE_PERSON})
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Person> getContributor();

	@OslcName("creator")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "creator")
	@OslcDescription("Creator or creators of resource (reference: Dublin Core). It is likely that the target resource will be a foaf:Person but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.LocalResource)
	@OslcRange({BugzillaCachedAdaptorConstants.TYPE_PERSON})
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Person> getCreator();

	@OslcName("type")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "type")
	@OslcDescription("A short string representation for the type, example 'Defect'.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.LocalResource)
	@OslcRange({BugzillaCachedAdaptorConstants.TYPE_TYPE})
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Type> getDctermsType();

	@OslcName("implementsRequirement")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "implementsRequirement")
	@OslcDescription("Implements associated Requirement. It is likely that the target resource will be an oslc_rm:Requirement but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getImplementsRequirement();

	@OslcName("relatedChangeRequest")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "relatedChangeRequest")
	@OslcDescription("This relationship is loosely coupled and has no specific meaning. It is likely that the target resource will be an oslc_cm:ChangeRequest but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getRelatedChangeRequest();

	@OslcName("relatedTestCase")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "relatedTestCase")
	@OslcDescription("Related QM test case resource. It is likely that the target resource will be an oslc_qm:TestCase but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getRelatedTestCase();

	@OslcName("relatedTestExecutionRecord")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "relatedTestExecutionRecord")
	@OslcDescription("Related to a QM test execution resource. It is likely that the target resource will be an oslc_qm:TestExecutionRecord but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getRelatedTestExecutionRecord();

	@OslcName("relatedTestPlan")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "relatedTestPlan")
	@OslcDescription("Related QM test plan resource. It is likely that the target resource will be an oslc_qm:TestPlan but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getRelatedTestPlan();

	@OslcName("relatedTestScript")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "relatedTestScript")
	@OslcDescription("Related QM test script resource. It is likely that the target resource will be an oslc_qm:TestScript but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getRelatedTestScript();

	@OslcName("subject")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "subject")
	@OslcDescription("Tag or keyword for a resource. Each occurrence of a dcterms:subject property denotes an additional tag for the resource.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.String)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<String> getSubject();

	@OslcName("testedByTestCase")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "testedByTestCase")
	@OslcDescription("Test case by which this change request is tested. It is likely that the target resource will be an oslc_qm:TestCase but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getTestedByTestCase();

	@OslcName("tracksChangeSet")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "tracksChangeSet")
	@OslcDescription("Tracks SCM change set resource. It is likely that the target resource will be an oslc_scm:ChangeSet but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getTracksChangeSet();

	@OslcName("tracksRequirement")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "tracksRequirement")
	@OslcDescription("Tracks the associated Requirement or Requirement ChangeSet resources. It is likely that the target resource will be an oslc_rm:Requirement but that is not necessarily the case.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<Link> getTracksRequirement();

	@OslcName("type")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.RDF_NAMSPACE + "type")
	@OslcDescription("The resource type URIs.")
	@OslcOccurs(Occurs.ZeroOrMany)
	@OslcReadOnly(false)
	@OslcTitle("")
    public HashSet<URI> getRdfType();

	@OslcName("approved")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "approved")
	@OslcDescription("Whether or not the Change Request has been approved.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isApproved();

	@OslcName("closed")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "closed")
	@OslcDescription("Whether or not the Change Request is completely done, no further fixes or fix verification is needed.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isClosed();

	@OslcName("closeDate")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "closeDate")
	@OslcDescription("The date at which no further activity or work is intended to be conducted.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.DateTime)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Date getCloseDate();

	@OslcName("created")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "created")
	@OslcDescription("Timestamp of resource creation")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.DateTime)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Date getCreated();

	@OslcName("description")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "description")
	@OslcDescription("Descriptive text about resource represented as rich text in XHTML content. SHOULD include only content that is valid and suitable inside an XHTML <div> element. ")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.XMLLiteral)
	@OslcReadOnly(false)
	@OslcTitle("")
    public String getDescription();

	@OslcName("discussedBy")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.OSLC_CORE_NAMSPACE + "discussedBy")
	@OslcDescription("A series of notes and comments about this resource.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public Link getDiscussedBy();

	@OslcName("fixed")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "fixed")
	@OslcDescription("Whether or not the Change Request has been fixed.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isFixed();

	@OslcName("identifier")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "identifier")
	@OslcDescription("A unique identifier for a resource. Typically read-only and assigned by the service provider when a resource is created. Not typically intended for end-user display.")
	@OslcOccurs(Occurs.ExactlyOne)
	@OslcValueType(ValueType.String)
	@OslcReadOnly(true)
	@OslcTitle("")
    public String getIdentifier();

	@OslcName("inprogress")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "inprogress")
	@OslcDescription("Whether or not the Change Request in a state indicating that active work is occurring. If oslc_cm:inprogress is true, then oslc_cm:fixed and oslc_cm:closed must also be false")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isInprogress();

	@OslcName("instanceShape")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.OSLC_CORE_NAMSPACE + "instanceShape")
	@OslcDescription("The URI of a Resource Shape that describes the possible properties, occurrence, value types, allowed values and labels. This shape information is useful in displaying the subject resource as well as guiding clients in performing modifications. Instance shapes may be specific to the authenticated user associated with the request that retrieved the resource, the current state of the resource and other factors and thus should not be cached.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Resource)
	@OslcReadOnly(false)
	@OslcTitle("")
    public Link getInstanceShape();

	@OslcName("modified")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "modified")
	@OslcDescription("Timestamp last latest resource modification")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.DateTime)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Date getModified();

	@OslcName("reviewed")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "reviewed")
	@OslcDescription("Whether or not the Change Request has been reviewed.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isReviewed();

	@OslcName("serviceProvider")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.OSLC_CORE_NAMSPACE + "serviceProvider")
	@OslcDescription("A link to the resource's OSLC Service Provider. There may be cases when the subject resource is available from a service provider that implements multiple domain specifications, which could result in multiple values for this property. ")
	@OslcOccurs(Occurs.ExactlyOne)
	@OslcReadOnly(false)
	@OslcTitle("")
    public URI getServiceProvider();

	@OslcName("shortTitle")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.OSLC_CORE_NAMSPACE + "shortTitle")
	@OslcDescription("Shorter form of dcterms:title for the resource represented as rich text in XHTML content. SHOULD include only content that is valid inside an XHTML <span> element.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.XMLLiteral)
	@OslcReadOnly(false)
	@OslcTitle("")
    public String getShortTitle();

	@OslcName("status")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "status")
	@OslcDescription("Used to indicate the status of the change request based on values defined by the service provider. Most often a read-only property. Some possible values may include: 'Submitted', 'Done', 'InProgress', etc.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.String)
	@OslcReadOnly(false)
	@OslcTitle("")
    public String getStatus();

	@OslcName("title")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.DUBLIN_CORE_NAMSPACE + "title")
	@OslcDescription("Title of the resource represented as rich text in XHTML content. SHOULD include only content that is valid inside an XHTML <span> element. ")
	@OslcOccurs(Occurs.ExactlyOne)
	@OslcValueType(ValueType.XMLLiteral)
	@OslcReadOnly(false)
	@OslcTitle("")
    public String getTitle();

	@OslcName("verified")
	@OslcPropertyDefinition(BugzillaCachedAdaptorConstants.CHANGE_MANAGEMENT_NAMSPACE + "verified")
	@OslcDescription("Whether or not the resolution or fix of the Change Request has been verified.")
	@OslcOccurs(Occurs.ZeroOrOne)
	@OslcValueType(ValueType.Boolean)
	@OslcReadOnly(true)
	@OslcTitle("")
    public Boolean isVerified();


    public void setAffectedByDefect(final HashSet<Link> affectedByDefect );
    public void setAffectsPlanItem(final HashSet<Link> affectsPlanItem );
    public void setAffectsRequirement(final HashSet<Link> affectsRequirement );
    public void setAffectsTestResult(final HashSet<Link> affectsTestResult );
    public void setBlocksTestExecutionRecord(final HashSet<Link> blocksTestExecutionRecord );
    public void setContributor(final HashSet<Person> contributor );
    public void setCreator(final HashSet<Person> creator );
    public void setDctermsType(final HashSet<Type> type );
    public void setImplementsRequirement(final HashSet<Link> implementsRequirement );
    public void setRelatedChangeRequest(final HashSet<Link> relatedChangeRequest );
    public void setRelatedTestCase(final HashSet<Link> relatedTestCase );
    public void setRelatedTestExecutionRecord(final HashSet<Link> relatedTestExecutionRecord );
    public void setRelatedTestPlan(final HashSet<Link> relatedTestPlan );
    public void setRelatedTestScript(final HashSet<Link> relatedTestScript );
    public void setSubject(final HashSet<String> subject );
    public void setTestedByTestCase(final HashSet<Link> testedByTestCase );
    public void setTracksChangeSet(final HashSet<Link> tracksChangeSet );
    public void setTracksRequirement(final HashSet<Link> tracksRequirement );
    public void setRdfType(final HashSet<URI> type );
    public void setApproved(final Boolean approved );
    public void setClosed(final Boolean closed );
    public void setCloseDate(final Date closeDate );
    public void setCreated(final Date created );
    public void setDescription(final String description );
    public void setDiscussedBy(final Link discussedBy );
    public void setFixed(final Boolean fixed );
    public void setIdentifier(final String identifier );
    public void setInprogress(final Boolean inprogress );
    public void setInstanceShape(final Link instanceShape );
    public void setModified(final Date modified );
    public void setReviewed(final Boolean reviewed );
    public void setServiceProvider(final URI serviceProvider );
    public void setShortTitle(final String shortTitle );
    public void setStatus(final String status );
    public void setTitle(final String title );
    public void setVerified(final Boolean verified );
}

